VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4815
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4095
   LinkTopic       =   "Form1"
   ScaleHeight     =   321
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   273
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdWrite 
      Caption         =   "Play"
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.PictureBox Picture1 
      Height          =   3615
      Left            =   120
      ScaleHeight     =   237
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   252
      TabIndex        =   2
      Top             =   1080
      Width           =   3840
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "STOP REC"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Record"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WHIn As WAVEHDR
Dim WHOut As WAVEHDR
Dim RecWaveBuffer As String

Private Sub cmdStart_Click()
Call StartLoop
End Sub

Sub StartLoop()
Dim RetVar As Long
Dim WFormat As WAVEFORMATEX

With WFormat
    .wFormatTag = WAVE_FORMAT_PCM
    .nChannels = 1
    .nBlockAlign = 1
    .nSamplesPerSec = 22050
    .wBitsPerSample = 8
    .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    .cbSize = 0
End With

RetVar = waveInOpen(hWaveIn, WAVE_MAPPER, WFormat, AddressOf waveInProc, 0, CALLBACK_FUNCTION)
If RetVar <> 0 Then MsgBox "ERROR": Exit Sub

waveInStart hWaveIn

Do
    With WHIn
        .lpData = VarPtr(WaveData(0))
        .dwBufferLength = 256
        .dwFlags = 0
    End With

    waveInPrepareHeader hWaveIn, WHIn, Len(WHIn)
    bBufferFull = False
    waveInAddBuffer hWaveIn, WHIn, Len(WHIn)

    Do
        DoEvents
    Loop Until bBufferFull Or hWaveIn = 0
    
    Dim tmp As String
    tmp = WaveData
    RecWaveBuffer = RecWaveBuffer & tmp
    
    DrawSpectr
    DoEvents
Loop Until hWaveIn = 0

End Sub

Private Sub cmdStop_Click()
waveInUnprepareHeader hWaveIn, WHIn, Len(WHIn)
waveOutUnprepareHeader hWaveOut, WHOut, Len(WHOut)

waveInReset hWaveIn
waveInStop hWaveIn
waveInClose hWaveIn
waveOutReset hWaveOut
waveOutClose hWaveOut
hWaveIn = 0
hWaveOut = 0
End Sub

Sub DrawSpectr()
Picture1.Cls
For i = 0 To 255
    Picture1.Line -(i, WaveData(i)), vbBlack
Next
End Sub

Private Sub cmdWrite_Click()
Dim RetVar As Long
Dim WFormat As WAVEFORMATEX

With WFormat
    .wFormatTag = WAVE_FORMAT_PCM
    .nChannels = 1
    .nSamplesPerSec = 22050
    .wBitsPerSample = 8
    .nBlockAlign = 1
    .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    .cbSize = 0
End With

RetVar = waveOutOpen(hWaveOut, WAVE_MAPPER, WFormat, AddressOf waveOutProc, 0, CALLBACK_FUNCTION)
If RetVar <> 0 Then MsgBox "ERROR": Exit Sub


':
waveOutBreakLoop hWaveOut

Dim WD() As Byte
WD = RecWaveBuffer

With WHOut
    .lpData = VarPtr(WD(0))
    .dwBufferLength = UBound(WD)
    .dwFlags = 0
End With

waveOutPrepareHeader hWaveOut, WHOut, Len(WHOut)
bBufferFull2 = False
waveOutWrite hWaveOut, WHOut, Len(WHOut)
End Sub


